<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.3
**********************************************/
// ------------------------------------------------------------------------- //
// Edited for phpmyForum v4.1.1 and Coppermine 1.4.3 by Roi Danton,          //
// based on the bridge files of the Coppermine Team                          //
// ------------------------------------------------------------------------- //

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 1);

require_once 'bridge/udb_base.inc.php';

class cpg_udb extends core_udb {

	function cpg_udb()
	{
		global $BRIDGE;

		if (!USE_BRIDGEMGR) { // the vars that are used when bridgemgr is disabled
			$this->boardurl = 'http://localhost/phpmyforum'; //TO EDIT: Full URL of pmF
			$this->use_post_based_groups = 1;
			//require_once('../phpmyforum/config.inc.php');

		} else { // the vars from the bridgemgr
			$this->boardurl = 'http://localhost/phpmyforum'; //TO EDIT: Full URL of pmF
			$this->use_post_based_groups = 1; //set this to zero if you don't need to use the pmF user groups in CPG

            //does not work properly (prompt to insert the data does not occur in CPG)
			//$this->boardurl = $BRIDGE['full_forum_url'];
			//require_once($BRIDGE['relative_path_to_config_file'] . 'config.php');
			//$this->use_post_based_groups = $BRIDGE['use_post_based_groups'];
		}

        $this->multigroups = 0;

		// Database connection settings
		$this->db = array(
			'name' => 'phpmyforum', //TO EDIT: your database name
			'host' => $dbhost ? $dbhost : 'localhost',
			'user' => 'root',       //TO EDIT: your database user name
			'password' => '',       //TO EDIT: your database user password
			'prefix' => 'pmf_'      //TO EDIT: prefix of your forums table
		);

		// Board table names
		$this->table = array(
			'users' => 'user',
			'groups' => 'group',
			'sessions' => 'session'
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		$this->sessionstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['sessions'];

		// Table field names
		$this->field = array(
			'username' => 'name', // name of 'username' field in users table
			'user_id' => 'id', // name of 'id' field in users table
			'password' => 'pass', // name of 'password' field in users table
			'email' => 'email', // name of 'email' field in users table
			'regdate' => 'reg', // name of 'registered' field in users table
			'location' => "''", // name of 'location' field in users table
			'website' => "''", // name of 'website' field in users table
			'usertbl_group_id' => 'group_id', // name of 'group id' field in users table
			'grouptbl_group_id' => 'id', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'name' // name of 'group name' field in groups table
		);

		// Pages to redirect to
		$this->page = array(
			'register' => '/signup.php',
			'editusers' => '/admin/user.php?action=result&',
			'edituserprofile' => '/user.php?action=profile&'
		);


		// Group ids - admin and guest only.
		$this->admingroups = array(1);
		$this->guestgroup = $this->use_post_based_groups ? 102 : 2;

		// Use a special function to collect groups for cpg groups table
		$this->group_overrride = 0;

		// Cookie settings - used in following functions only
		// $this->cookie_name = $cookieprefix;

		// Connect to db
		$this->connect();
	}

	// definition of how to extract id, name, group from a session cookie
	function session_extraction()
	{
		if (isset($_COOKIE[$this->cookie_name . 'pmfSess'])) {
			$session_id = addslashes($_COOKIE[$this->cookie_name . 'pmfSess']);

  	        $sql = "SELECT u.{$this->field['user_id']} AS user_id, u.{$this->field['password']} AS password, u.{$this->field['usertbl_group_id']}+100 AS usergroupid FROM {$this->usertable} AS u, {$this->sessionstable} AS s WHERE u.{$this->field['user_id']}=s.user_id AND s.sess = '$session_id'";

			$result = cpg_db_query($sql, $this->link_id);

			if (mysql_num_rows($result)){
				$row = mysql_fetch_array($result);
				return $row;
			} else {
			    return false;
			}
		}
	}

	// definition of how to extract an id and password hash from a cookie
	function cookie_extraction()
	{
	    $id = 0;
		$pass = '';

		if (isset($_COOKIE['pmfUserId']) && isset($_COOKIE['pmfPass'])) {
			$id = (int)$_COOKIE['pmfUserId'];
			$pass = addslashes($_COOKIE['pmfPass']);
		}

		return ($id) ? array($id, $pass) : false;
	}

	// Get groups of which user is member
	function get_groups($row)
	{
		$data[0] = in_array($row[$this->field['usertbl_group_id']] - 100, $this->admingroups) ? 1 : 3;

		if ($this->use_post_based_groups){
			$sql = "SELECT g.{$this->field['grouptbl_group_id']}+100 AS group_id, u.* FROM {$this->usertable} AS u, {$this->groupstable} as g WHERE g.{$this->field['grouptbl_group_id']} = u.{$this->field['usertbl_group_id']} AND u.{$this->field['user_id']} = '{$row[$this->field['user_id']]}'";

			$result = cpg_db_query($sql, $this->link_id);

			$row = mysql_fetch_array($result);

			$data[0] = $row['group_id'];

			if ($row['membergroupids']){
				$groups = explode(',', $row['membergroupids']);
				foreach ($groups as $id => $group){
					$data[] = $group+100;
				}
			}
		}

		return $data;
	}

	// View user profile
	function view_profile($uid)
	{

	}

	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password; // unused
	}

	function login_page()
	{
		$this->redirect("/login.php");
	}

	function logout_page()
	{
		$this->redirect("/login.php?action=logout&");
	}
}

// and go !
$cpg_udb = new cpg_udb;



